%define use_alternatives 1

%{!?dist: %define dist .slc5}                                                   
%define debug_package %{nil}

Summary: CERN LDAP printer database client and integration sctipts
Name: lpadmincern
Version: 1.0.2
Release: 1%{?dist}
Source0: %{name}-%{version}.tar.gz
Group: CERN/Utilities
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Packager: Linux.Support@cern.ch
Vendor:  CERN 
License: GPL
Requires: cups >= 1.1, perl, perl-LDAP
BuildRequires: perl 
BuildArch: noarch
Provides: /usr/bin/cancel /usr/bin/lp /usr/bin/lpq /usr/bin/lpr /usr/bin/lprm /usr/bin/lpstat /usr/sbin/lpc
Prereq: /usr/sbin/alternatives
# below: to migrate on SLC4
Obsoletes: xprint-cups
Provides: xprint-cups
Obsoletes: cern-config-printers
Provides: cern-config-printers


%description
lpadmincern is the CERN LDAP printer database client.
It acts as an frontend to system printing spooler - CUPS
and allows configuration of CERN printers on the system.

Additional scripts provide integration of local system 
lp clients and CERN printing infrastructure.


%changelog
* Wed Mar 10 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 1.0.1
- cleanup of unused PPDs, better name/model bindings.
* Fri Mar 05 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 1.0
- Unify printer bindings on SLC4/SLC5
* Thu Mar 04 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.9
- port old xprint-cups integration scripts
* Tue Mar 02 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.7
- make it work for both SLC4 and SLC5
* Wed Feb 10 2010 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.6
- removed 1000 matches limitation.
* Wed May 27 2009 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.5
- fixed to use xldap.cern.ch
* Tue Jan 13 2009 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.4
- fixed the --default switch 
* Fri Oct 17 2008 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.3
- fixes in some broken HP ppds
- fixes for Duplex enabled while Duplex Unit not installed cases..
  (on HP printers..)

* Fri Oct 17 2008 Jaroslaw Polok <jaroslaw.polok@cern.ch> 0.1
- initial build 
%prep
%setup 

%build

pod2man %{name}.pl > %{name}.1

%install
mkdir -p $RPM_BUILD_ROOT/%{_sbindir}
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT/etc/cron.daily/
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d/
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/%{name}/ppds/

install -m 755 %{name}.pl $RPM_BUILD_ROOT/%{_sbindir}/%{name}
install -m 644 %{name}.1 $RPM_BUILD_ROOT/%{_mandir}/man1/
install -m 644 ppds/* $RPM_BUILD_ROOT/%{_datadir}/%{name}/ppds/

install -m755 lpq-cern.py $RPM_BUILD_ROOT%{_bindir}/lpq.cern
install -m755 lprm-cern.py $RPM_BUILD_ROOT%{_bindir}/lprm.cern
install -m755 lpadmincern.cron $RPM_BUILD_ROOT/etc/cron.daily/lpadmincern
install -m755 lpadmincern.logrotate $RPM_BUILD_ROOT/etc/logrotate.d/lpadmincern

pushd $RPM_BUILD_ROOT%{_bindir}
ln -sf cancel.cups cancel.cern
ln -sf lp.cups lp.cern
ln -sf lpr.cups lpr.cern
ln -sf lpstat.cups lpstat.cern
cd $RPM_BUILD_ROOT%{_sbindir}
ln -sf lpc.cups lpc.cern
popd

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8

install -m644 man/cancel-cern.1 $RPM_BUILD_ROOT%{_mandir}/man1/cancel-cern.1
install -m644 man/lp-cern.1 $RPM_BUILD_ROOT%{_mandir}/man1/lp-cern.1
install -m644 man/lpq-cern.1 $RPM_BUILD_ROOT%{_mandir}/man1/lpq-cern.1
install -m644 man/lpr-cern.1 $RPM_BUILD_ROOT%{_mandir}/man1/lpr-cern.1
install -m644 man/lprm-cern.1 $RPM_BUILD_ROOT%{_mandir}/man1/lprm-cern.1
install -m644 man/lpstat-cern.1 $RPM_BUILD_ROOT%{_mandir}/man1/lpstat-cern.1
install -m644 man/lpc-cern.8 $RPM_BUILD_ROOT%{_mandir}/man8/lpc-cern.8

pushd $RPM_BUILD_ROOT%{_mandir}/man1
gzip cancel-cern.1 lp-cern.1 lpq-cern.1 lpr-cern.1 lprm-cern.1 lpstat-cern.1
cd $RPM_BUILD_ROOT%{_mandir}/man8
gzip lpc-cern.8
popd

%clean

rm -rf $RPM_BUILD_ROOT



%files
%defattr(-,root,root)
%doc README
%{_sbindir}/%{name}
%{_bindir}/cancel.cern
%{_bindir}/lp.cern
%{_bindir}/lpq.cern
%{_bindir}/lpr.cern
%{_bindir}/lprm.cern
%{_bindir}/lpstat.cern
%{_sbindir}/lpc.cern
%dir %{_datadir}/%{name}/ppds
%{_datadir}/%{name}/ppds/*
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/cancel-cern.1.gz
%{_mandir}/man1/lp-cern.1.gz
%{_mandir}/man1/lpq-cern.1.gz
%{_mandir}/man1/lpr-cern.1.gz
%{_mandir}/man1/lprm-cern.1.gz
%{_mandir}/man1/lpstat-cern.1.gz
%{_mandir}/man8/lpc-cern.8.gz
/etc/logrotate.d/lpadmincern
%config(noreplace) /etc/cron.daily/lpadmincern

%post
/usr/sbin/alternatives --install %{_bindir}/lpr print %{_bindir}/lpr.cern 55 \
	--slave %{_bindir}/cancel print-cancel %{_bindir}/cancel.cern \
         --slave %{_bindir}/lp print-lp %{_bindir}/lp.cern \
         --slave %{_bindir}/lpq print-lpq %{_bindir}/lpq.cern \
         --slave %{_bindir}/lprm print-lprm %{_bindir}/lprm.cern \
         --slave %{_bindir}/lpstat print-lpstat %{_bindir}/lpstat.cern \
         --slave %{_sbindir}/lpc print-lpc %{_sbindir}/lpc.cern \
         --slave %{_mandir}/man1/cancel.1.gz print-cancelman %{_mandir}/man1/cancel-cern.1.gz \
         --slave %{_mandir}/man1/lp.1.gz print-lpman %{_mandir}/man1/lp-cern.1.gz \
         --slave %{_mandir}/man1/lpq.1.gz print-lpqman %{_mandir}/man1/lpq-cern.1.gz \
         --slave %{_mandir}/man1/lpr.1.gz print-lprman %{_mandir}/man1/lpr-cern.1.gz \
         --slave %{_mandir}/man1/lprm.1.gz print-lprmman %{_mandir}/man1/lprm-cern.1.gz \
         --slave %{_mandir}/man1/lpstat.1.gz print-lpstatman %{_mandir}/man1/lpstat-cern.1.gz \
         --slave %{_mandir}/man8/lpc.8.gz print-lpcman %{_mandir}/man8/lpc-cern.8.gz \
         --initscript cups

/usr/sbin/alternatives --auto print

echo "enabling and starting cups, please wait..."
/sbin/chkconfig --add cups 2>&1 >> /dev/null ||:
/sbin/service cups restart 2>&1 >> /dev/null ||:

echo "Updating all printers definitions, please wait..."
/usr/sbin/lpadmincern -u

exit 0

%preun
if [ "$1" = "0" ]; then
        /usr/sbin/alternatives --remove print %{_bindir}/lpr.cern
fi
exit 0

%triggerin -- cups
/sbin/chkconfig --add cups 2>&1 >> /dev/null ||:
/sbin/service cups restart 2>&1 >> /dev/null ||:


